/* 3DS STUFF --------------------------------------------- */

function scrollBack() {
	setTimeout("window.scrollTo(39, 218)",1);
}
window.onmousemove = scrollBack;
window.onload = scrollBack;

/* ------------------------------------------------------- */

// GLOBAL VARIABLES
var digitsMaximum = 16; // The number of maximum digits that can be entered in the display is this value minus one (i.e., 15).
var maxPushLevels = 12; // This defines the maximum number of levels ("tiers" on the stack) that are allowed to be pushed into.
var nhdigits = 8;
var valueMaximum = 4294967296; // 2^32
var hexdigits = "" + "0123456789ABCDEF";
var stack = new array(maxPushLevels); //Creates a stack containing a maximum number of tiers equal to maxPushLevels.
var angleMeasure = "deg"; // "Memory" for which angle measurement is checked. Values can be "deg", "rad", or "grad".

var value = 0;		// current value in display
var stackTier = 0;		// no. of items on stack
var isItThere = true;	// If isItThere is true, then the value on the display has been entered.
var decimal = 0;		// multiplier when entering after decimal point
var fixed = 0;		// force trailing zero display when entering decimals
var expMode = false;	// currently entering EE mode?
var base = 10; // current base (16, 10, 8, or 2)
// END GLOBAL VARIABLES

function updateGui(e) {
	if (e=="select_deg") {
		document.getElementById("trigRad").className = "btn btn_degr degr_rad";
		document.getElementById("trigDeg").className = "btn btn_degr_sel degr_deg";
		document.getElementById("trigGrad").className = "btn btn_degr degr_grd";
	}
	else if (e=="select_rad") {
		document.getElementById("trigRad").className = "btn btn_degr_sel degr_rad";
		document.getElementById("trigDeg").className = "btn btn_degr degr_deg";
		document.getElementById("trigGrad").className = "btn btn_degr degr_grd";
	}
	else if (e=="select_grad") {
		document.getElementById("trigRad").className = "btn btn_degr degr_rad";
		document.getElementById("trigDeg").className = "btn btn_degr degr_deg";
		document.getElementById("trigGrad").className = "btn btn_degr_sel degr_grd";
	}
	else if (e=="select_dec") {
		document.getElementById("baseHex").className = "btn btn_base base_hex";
		document.getElementById("baseDec").className = "btn btn_base_sel base_dec";
		document.getElementById("baseOct").className = "btn btn_base base_oct";
		document.getElementById("baseBin").className = "btn btn_base base_bin";
		//functions
		document.getElementById("funcPi").className = "btn btn_func func_pi";
		document.getElementById("funcSin").className = "btn btn_func func_sin";
		document.getElementById("funcCos").className = "btn btn_func func_cos";
		document.getElementById("funcTan").className = "btn btn_func func_tan";
		document.getElementById("funcAsin").className = "btn btn_func func_asin";
		document.getElementById("funcAcos").className = "btn btn_func func_acos";
		document.getElementById("funcAtan").className = "btn btn_func func_atan";
		document.getElementById("funcExp").className = "btn btn_func func_exp";
		document.getElementById("digitPeriod").className = "btn btn_inpt inpt_p";
		document.getElementById("digitSign").className = "btn btn_inpt inpt_s";
		//digits
		document.getElementById("digit2").className = "btn btn_inpt inpt_2";
		document.getElementById("digit3").className = "btn btn_inpt inpt_3";
		document.getElementById("digit4").className = "btn btn_inpt inpt_4";
		document.getElementById("digit5").className = "btn btn_inpt inpt_5";
		document.getElementById("digit6").className = "btn btn_inpt inpt_6";
		document.getElementById("digit7").className = "btn btn_inpt inpt_7";
		document.getElementById("digit8").className = "btn btn_inpt inpt_8";
		document.getElementById("digit9").className = "btn btn_inpt inpt_9";
		document.getElementById("digitA").className = "btn btn_inpt inpt_a disabled";
		document.getElementById("digitB").className = "btn btn_inpt inpt_b disabled";
		document.getElementById("digitC").className = "btn btn_inpt inpt_c disabled";
		document.getElementById("digitD").className = "btn btn_inpt inpt_d disabled";
		document.getElementById("digitE").className = "btn btn_inpt inpt_e disabled";
		document.getElementById("digitF").className = "btn btn_inpt inpt_f disabled";
	}
	else if (e=="select_not_dec") {
		document.getElementById("funcPi").className = "btn btn_func func_pi disabled";
		document.getElementById("funcSin").className = "btn btn_func func_sin disabled";
		document.getElementById("funcCos").className = "btn btn_func func_cos disabled";
		document.getElementById("funcTan").className = "btn btn_func func_tan disabled";
		document.getElementById("funcAsin").className = "btn btn_func func_asin disabled";
		document.getElementById("funcAcos").className = "btn btn_func func_acos disabled";
		document.getElementById("funcAtan").className = "btn btn_func func_atan disabled";
		document.getElementById("funcExp").className = "btn btn_func func_exp disabled";
		document.getElementById("digitPeriod").className = "btn btn_inpt inpt_p disabled";
		document.getElementById("digitSign").className = "btn btn_inpt inpt_s disabled";
	}
	else if (e=="select_hex") {
		document.getElementById("baseHex").className = "btn btn_base_sel base_hex";
		document.getElementById("baseDec").className = "btn btn_base base_dec";
		document.getElementById("baseOct").className = "btn btn_base base_oct";
		document.getElementById("baseBin").className = "btn btn_base base_bin";
		//digits
		document.getElementById("digit2").className = "btn btn_inpt inpt_2";
		document.getElementById("digit3").className = "btn btn_inpt inpt_3";
		document.getElementById("digit4").className = "btn btn_inpt inpt_4";
		document.getElementById("digit5").className = "btn btn_inpt inpt_5";
		document.getElementById("digit6").className = "btn btn_inpt inpt_6";
		document.getElementById("digit7").className = "btn btn_inpt inpt_7";
		document.getElementById("digit8").className = "btn btn_inpt inpt_8";
		document.getElementById("digit9").className = "btn btn_inpt inpt_9";
		document.getElementById("digitA").className = "btn btn_inpt inpt_a";
		document.getElementById("digitB").className = "btn btn_inpt inpt_b";
		document.getElementById("digitC").className = "btn btn_inpt inpt_c";
		document.getElementById("digitD").className = "btn btn_inpt inpt_d";
		document.getElementById("digitE").className = "btn btn_inpt inpt_e";
		document.getElementById("digitF").className = "btn btn_inpt inpt_f";
	}
	else if (e=="select_bin") {
		document.getElementById("baseHex").className = "btn btn_base base_hex";
		document.getElementById("baseDec").className = "btn btn_base base_dec";
		document.getElementById("baseOct").className = "btn btn_base base_oct";
		document.getElementById("baseBin").className = "btn btn_base_sel base_bin";
		//digits
		document.getElementById("digit2").className = "btn btn_inpt inpt_2 disabled";
		document.getElementById("digit3").className = "btn btn_inpt inpt_3 disabled";
		document.getElementById("digit4").className = "btn btn_inpt inpt_4 disabled";
		document.getElementById("digit5").className = "btn btn_inpt inpt_5 disabled";
		document.getElementById("digit6").className = "btn btn_inpt inpt_6 disabled";
		document.getElementById("digit7").className = "btn btn_inpt inpt_7 disabled";
		document.getElementById("digit8").className = "btn btn_inpt inpt_8 disabled";
		document.getElementById("digit9").className = "btn btn_inpt inpt_9 disabled";
		document.getElementById("digitA").className = "btn btn_inpt inpt_a disabled";
		document.getElementById("digitB").className = "btn btn_inpt inpt_b disabled";
		document.getElementById("digitC").className = "btn btn_inpt inpt_c disabled";
		document.getElementById("digitD").className = "btn btn_inpt inpt_d disabled";
		document.getElementById("digitE").className = "btn btn_inpt inpt_e disabled";
		document.getElementById("digitF").className = "btn btn_inpt inpt_f disabled";
	}
	else if (e=="select_oct") {
		document.getElementById("baseHex").className = "btn btn_base base_hex";
		document.getElementById("baseDec").className = "btn btn_base base_dec";
		document.getElementById("baseOct").className = "btn btn_base_sel base_oct";
		document.getElementById("baseBin").className = "btn btn_base base_bin";
		//digits
		document.getElementById("digit2").className = "btn btn_inpt inpt_2";
		document.getElementById("digit3").className = "btn btn_inpt inpt_3";
		document.getElementById("digit4").className = "btn btn_inpt inpt_4";
		document.getElementById("digit5").className = "btn btn_inpt inpt_5";
		document.getElementById("digit6").className = "btn btn_inpt inpt_6";
		document.getElementById("digit7").className = "btn btn_inpt inpt_7";
		document.getElementById("digit8").className = "btn btn_inpt inpt_8 disabled";
		document.getElementById("digit9").className = "btn btn_inpt inpt_9 disabled";
		document.getElementById("digitA").className = "btn btn_inpt inpt_a disabled";
		document.getElementById("digitB").className = "btn btn_inpt inpt_b disabled";
		document.getElementById("digitC").className = "btn btn_inpt inpt_c disabled";
		document.getElementById("digitD").className = "btn btn_inpt inpt_d disabled";
		document.getElementById("digitE").className = "btn btn_inpt inpt_e disabled";
		document.getElementById("digitF").className = "btn btn_inpt inpt_f disabled";
	}
}

function angleConvert(e){
	if (e == "deg"){
		if (base == 10) {
			if (angleMeasure == "rad"){
				value = (180 / Math.PI) * value;
			}
			else if (angleMeasure == "grad"){
				value = (180 / 200) * value;
			}
		}
		angleMeasure = "deg";
		updateGui("select_deg");
	}
	else if (e == "rad"){
		if (base == 10) {
			if (angleMeasure == "deg"){
				value = (Math.PI / 180) * value;
			}
			else if (angleMeasure == "grad"){
				value = (Math.PI / 200) * value;
			}
		}
		angleMeasure = "rad";
		updateGui("select_rad");
	}
	else if (e == "grad"){
		if (base == 10) {
			if (angleMeasure == "deg"){
				value = (200 / 180) * value;
			}
			else if (angleMeasure == "rad"){
				value = (200 / Math.PI) * value;
			}
		}
		angleMeasure = "grad";
		updateGui("select_grad");
	}
	equals();
}

function setNumberBase(e){
	if(e == 10){
		base=10;
		equals();
		updateGui("select_dec");
	}
	else{
		if(e == 16){
			base=16;
			equals();
			updateGui("select_hex");
		}
		else if(e == 8){
			base=8;
			equals();
			updateGui("select_oct");
			
		}
		else if(e == 2){
			base=2;
			equals();
			updateGui("select_bin");
		}
		updateGui("select_not_dec");
	}
}

function freshstart() {
	var display = format(value);
	display = "               " + display;
	display = display.substring(display.length-digitsMaximum-1,display.length);
	topbar.result.value = display;
	func("memclearall");
	setNumberBase(10);
	angleConvert("deg");
}

function stackPushTier() {
	this.value = 0;
	this.op = "";
}

function array(length) {
	this[0] = 0;
	for (i=0; i<length; ++i){
		this[i] = 0;
		this[i] = new stackPushTier();
	}
	this.length = length;
}

function push(value,op,prec) {
	if (stackTier==maxPushLevels){
		return false;
	}
	for (i=stackTier;i>0; --i){
		stack[i].value = stack[i-1].value;
		stack[i].op = stack[i-1].op;
		stack[i].prec = stack[i-1].prec;
	}
	stack[0].value = value;
	stack[0].op = op;
	stack[0].prec = prec;
	++stackTier;
	return true;
}

function pop() {
	if (stackTier==0){
		return false;
	}
	for (i=0;i<stackTier; ++i){
		stack[i].value = stack[i+1].value;
		stack[i].op = stack[i+1].op;
		stack[i].prec = stack[i+1].prec;
	}
	--stackTier;
	return true;
}

function format(val) {
	if (base == 10){
	 	var valStr = "" + value;
	 	if (valStr.indexOf("N")>=0 || (value == 2*value && value == 1+value))
			return "Error ";
		var i = valStr.indexOf("e")
		if (i>=0)
		{
			var expStr = valStr.substring(i+1,valStr.length);
			if (i>11) i=11;  // max 11 digits
			valStr = valStr.substring(0,i);
			if (valStr.indexOf(".")<0) valStr += ".";
	 		valStr += " " + expStr;
	 	}
	 	else
	 	{
	 		var valNeg = false;
	 		if (value < 0)
	 			{ value = -value; valNeg = true; }
	
	 		var valInt = Math.floor(value);
	 		var valFrac = value - valInt;
	 		var prec = digitsMaximum - (""+valInt).length - 1;	// how many digits available after period
	 		if (! isItThere && fixed>0)
				prec = fixed;
			var mult = " 1000000000000000000".substring(1,prec+2);
			var frac = Math.floor(valFrac * mult + 0.5);
	
			valInt = Math.floor(Math.floor(value * mult + .5) / mult);
	
			if (valNeg)
				valStr = "-" + valInt;
			else
				valStr = "" + valInt;

			var fracStr = "00000000000000"+frac;
			fracStr = fracStr.substring(fracStr.length-prec, fracStr.length);
			i = fracStr.length-1;
			if (isItThere || fixed==0)
			{
				// remove trailing zeros unless fixed during entry.
				while (i>=0 && fracStr.charAt(i)=="0")
					--i;
				fracStr = fracStr.substring(0,i+1);
			}
			if (i>=0) valStr += "." + fracStr;
		}
		return valStr;
	}
	else {
		var s = "";
		if (val<0 || val>valueMaximum)
			return "Error";
		if (val==0)
			return "0";
		if (base<2) {
			while (val && s.length < 20) {
				var x = val % 16;
				var d = hexdigits.charAt(x);
				val = (val-x)/16 | 0;
				var y = val % 16;
				var e = hexdigits.charAt(y);
				val = (val-y)/16 | 0;
				s = "%" + e + d + s;
			}
			s = '"' + s + '"';
			return unescape(s);
		}
		while (val && s.length < 20) {
			var x = val % base;
			var d = hexdigits.charAt(x);
			val = (val-x)/base | 0;
			s = "" + d + s;
		}
		return s;
	}
}

function update(){
	if(base == 10) {
		var display = format(value);
		if (expMode) {
			if (expval<0)
				display += " " + expval;
			else
				display += " +" + expval;
		}
		if (display.indexOf(".")<0 && display != "Error ") {
			if (isItThere || decimal>0)
				display += '.';
			else
				display += ' ';
		}
		display = "               " + display;
		display = display.substring(display.length-digitsMaximum-1,display.length);
		topbar.result.value = display;
		myString = topbar.result.value;
	}
	else{
		value = value % valueMaximum;
		if (value<0)
			value = value + valueMaximum;
		var display = format(value);
		if (isItThere)
			display += ".";
		else
			display += " ";
		display = "                 " + display;
		display = display.substring(display.length-digitsMaximum-1,display.length);
		topbar.result.value = display;
	}
}

function clearAll(){
	stackTier = 0;
	clear();
}

function clear(){
	expMode = false;
	value = 0;
	enter();
	update();
}

function evalx(){
	if (stackTier==0){
		//alert("stackTier==0");
		return false;
	}
	op = stack[0].op;
	sval = stack[0].value;
	// alert("eval "+sval+op+value);
	if (op == "+")
		value = sval + value;
	else if (op == '-')
		value = sval - value;
	else if (op == '*')
		value = sval * value;
	else if (op == '/')
		value = sval / value;
	else if (op == '%')
		value = sval % value;
	else if (op == 'pow')
		value = Math.pow(sval,value);
	else if(op == "and")
		value = sval & value;
	else if(op == "or")
		value = sval | value;
	else if(op == "xor")
		value = sval ^ value;
	else if(op == "lsh")
		value = sval << value;
	else if(op == "rsh")
		value = sval >> value;
	pop();
	if (op=='(')
		return false;
	return true;
}

function openp(){
	enter();
	if (!push(0,'(',0))
		value = "NAN";
	// historymenu.innerHTML += "(";
	update();
}

function closep(){
	enter();
	while (evalx());
	// historymenu.innerHTML += ")";
	update();
}

function mathOp(op){
	enter();
	if(base == 10){
		if (op=='+' || op=='-')
			prec = 1;
		else if (op=='*' || op=='/' || op=='%') // op=='%' was added (blippie)
			prec = 2;
		else if (op=="pow")
			prec = 3;
		else if (op=="or" || op=='xor') // this statement wasn't originally here
			prec = 4;
		else if (op=="and") // this statement wasn't originally here
			prec = 5;
		else if(op=="lsh" || op=="rsh") // this statement wasn't originally here
			prec = 6;
		if (stackTier>0 && prec <= stack[0].prec)
			evalx();
		if (!push(value,op,prec))
			value = "NAN";
		update();
		/*
		if(op == "pow")
			historymenu.innerHTML += " ^ ";
		else
			historymenu.innerHTML += op;
		*/
	}
	else {
		if (op=='+' || op=='-')
			prec = 1;
		else if (op=='*' || op=='/' || op=='%') // op=='%' was added (blippie)
			prec = 2;
		else if(op=='pow')
			prec = 3;
		else if (op=="or" || op=='xor')
			prec = 4; // original value: prec = 3;
		else if (op=="and")
			prec = 5; // original value: prec = 4;
		else if(op=="lsh" || op=="rsh") // this statement wasn't originally here
			prec = 6;
		else
			value = "NAN";

		if (stackTier>0 && prec <= stack[0].prec)
			evalx();
		if (!push(value,op,prec))
			value = "NAN";
		update();
	}
}

function enter() {
	isItThere = true;
	if (base == 10) {
		if (expMode)
			//alert(expval);
			value = value * Math.exp(expval * Math.LN10);
		expMode = false;
		decimal = 0;
		fixed = 0;
	}
}

function equals() {
	enter();
	while (stackTier>0)
		evalx();
	update();
	// historymenu.innerHTML += " = "+myString+"<BR>";
}

function digit(n){
	if (n >= base)	//disable flag
		return;
	if(base == 10){
		if (isItThere){
			value = 0;
			digits = 0;
			isItThere = false;
		}
		if (n==0 && digits==0){
			update();
			return;
		}
		if (expMode) {
			if (expval<0){
				n = -n;
			}
			if (digits < 3){
				expval = expval * 10 + n;
				++digits;
				update();
			}
			return;
		}
		if (value<0)
			n = -n;
		if (digits < digitsMaximum-1){
			++digits;
			if (decimal>0){
				decimal = decimal * 10;
				value = value + (n/decimal);
				++fixed;
			}
			else
				value = value * 10 + n;
		}
		update();
		// historymenu.innerHTML += n;
	}
	else{
		if (isItThere){
			value = 0;
			digits = 0;
		}
		if (n>=base)
			return;
		isItThere = false;
		if (value<0)
			n = -n;
		if (digits < nhdigits){
			value = value * base + n;
			++digits;
		}
		update();
	}
}

function sign() {
	if (base != 10) //disable flag
		return;
	if (expMode)
		expval = -expval;
	else
		value = -value;
	update();
}

function period() {
	if (base != 10) //disable flag
		return;
	if (isItThere) {
		value = 0;
		digits = 1;
	}
	isItThere = false;
	if (decimal == 0)
			decimal = 1;
	// historymenu.innerHTML += ".";
	update();
}

function exp(){
	if(base != 10) //disable flag
		return;
	if (isItThere || expMode)
			return;
	expMode = true;
	expval = 0;
	digits = 0;
	decimal = 0;
	update();
}

function func(f){
	oldValue = value; // Used for history menu.
	enter();
	if (f=="1/x"){
		value = 1/value;
		// historymenu.innerHTML += "<BR>(" + oldValue + ")<SUP>-1</SUP> = " + format(value);
	}
	else if (f=="n!"){
		value = Math.floor(value);
		oldFactValue = value;
		if (value<0 || value>200)
			value = "NAN";
		else{
			var n = 1;
			var i;
			for (i=1;i<=value;++i)
				n *= i;
		}
		value = n;
		// historymenu.innerHTML += "<BR>(" + oldFactValue + ")! = " + value;
	}
	else if (f=="log"){
		value = Math.log(value)/Math.LN10;
		// historymenu.innerHTML += "<BR>log<SUB>10</SUB>(" + oldValue + ") = " + format(value);
	}
	else if (f=="log2"){
		value = Math.log(value)/Math.LN2;
		// historymenu.innerHTML += "<BR>log<sub>2</SUB>(" + oldValue + ") = " + format(value);
	}
	else if (f=="ln"){
		value = Math.log(value);
		// historymenu.innerHTML += "<BR>ln(" + oldValue + ") = " + format(value);
	}
	else if (f=="sqrt"){
		value = Math.sqrt(value);
		// historymenu.innerHTML += "<BR>sqrt(" + oldValue + ") = " + format(value);
	}
	else if (f=="leftshift"){
		value = value << 1;
	}
	else if (f=="rightshift"){
		value = value >> 1;
	}
	else if(f=="10tox"){
		value = Math.exp(value * Math.LN10);
		// historymenu.innerHTML += "<BR>10<SUP>(" + oldValue + ")</SUP> = " + format(value);
	}
	else if(f=="etox"){
		value = Math.exp(value);
		// historymenu.innerHTML += "<BR>e<SUP>(" + oldValue + ")</SUP> = " + format(value);
	}
	else if(f=="2tox"){
		value = Math.exp(value * Math.LN2);
		// historymenu.innerHTML += "<BR>2<SUP>(" + oldValue + ")</SUP> = " + format(value);
	}
	else if(f=="xsq"){
		value = value*value;
		// historymenu.innerHTML += "<BR>(" + oldValue + ")<SUP>2</SUP> = " + format(value);
	}
	else if(f=="not"){
		value = ~ value;
	}
	else if(f=="memclearall"){
		document.getElementById("meminput1").innerHTML = "";
		document.getElementById("meminput2").innerHTML = "";
		document.getElementById("meminput3").innerHTML = "";
		document.getElementById("meminput4").innerHTML = "";
		document.getElementById("meminput5").innerHTML = "";
	}
	else if(f=="memplus1"){
		document.getElementById("meminput1").innerHTML = value;
	}
	else if(f=="memrecall1"){
		value = parseFloat(document.getElementById("meminput1").innerHTML);
	}
	else if(f=="memclear1"){
		document.getElementById("meminput1").innerHTML = "";
	}
	else if(f=="memplus2"){
		document.getElementById("meminput2").innerHTML = value;
	}
	else if(f=="memrecall2"){
		value = parseFloat(document.getElementById("meminput2").innerHTML);
	}
	else if(f=="memclear2"){
		document.getElementById("meminput2").innerHTML = "";
	}
	else if(f=="memplus3"){
		document.getElementById("meminput3").innerHTML = value;
	}
	else if(f=="memrecall3"){
		value = parseFloat(document.getElementById("meminput3").innerHTML);
	}
	else if(f=="memclear3"){
		document.getElementById("meminput3").innerHTML = "";
	}
	else if(f=="memplus4"){
		document.getElementById("meminput4").innerHTML = value;
	}
	else if(f=="memrecall4"){
		value = parseFloat(document.getElementById("meminput4").innerHTML);
	}
	else if(f=="memclear4"){
		document.getElementById("meminput4").innerHTML = "";
	}
	else if(f=="memplus5"){
		document.getElementById("meminput5").innerHTML = value;
	}
	else if(f=="memrecall5"){
		value = parseFloat(document.getElementById("meminput5").innerHTML);
	}
	else if(f=="memclear5"){
		document.getElementById("meminput5").innerHTML = "";
	}
	update();
}

function trigfunc(f){
	if (base != 10) //disable flag
		return;
	oldValue = value; // Used for history menu.
	enter();
	if(f=="sin"){
		if(angleMeasure=="deg"){
			value = Math.sin(value * Math.PI / 180);
		}
		else if(angleMeasure=="rad"){
			value = Math.sin(value);
		}
		else if(angleMeasure=="grad"){
			value = Math.sin(value * Math.PI / 200);
		}
		// historymenu.innerHTML += "<BR>sin(" + oldValue + ") = " + format(value);
	}
	else if (f=="cos"){
		if(angleMeasure=="deg"){
			value = Math.cos(value * Math.PI / 180);
		}
		else if(angleMeasure=="rad"){
			value = Math.cos(value);
		}
		else if(angleMeasure=="grad"){
			value = Math.cos(value * Math.PI / 200);
		}

		// historymenu.innerHTML += "<BR>cos(" + oldValue + ") = " + format(value);
	}
	else if (f=="tan"){
		if(angleMeasure=="deg"){
			value = Math.tan(value * Math.PI / 180);
		}
		else if(angleMeasure=="rad"){
			value = Math.tan(value);
		}
		else if(angleMeasure=="grad"){
			value = Math.tan(value * Math.PI / 200);
		}
		// historymenu.innerHTML += "<BR>tan(" + oldValue + ") = " + format(value);
	}
	else if (f=="pi"){
		value = Math.PI;
		// historymenu.innerHTML += Math.PI;
	}
	else if (f=="acos"){
		if(angleMeasure=="deg"){
			value = Math.acos(value) * (180 / Math.PI);
		}
		else if(angleMeasure=="rad"){
			value = Math.acos(value);
		}
		else if(angleMeasure=="grad"){
			value = Math.acos(value) * (200 / Math.PI);
		}
		// historymenu.innerHTML += "<BR>cos<SUP>-1</SUP>(" + oldValue + ") = " + format(value);
	}
	else if(f=="asin"){
		if(angleMeasure=="deg"){
			value = Math.asin(value) * (180 / Math.PI);
		}
		else if(angleMeasure=="rad"){
			value = Math.asin(value);
		}
		else if(angleMeasure=="grad"){
			value = Math.asin(value) * (200 / Math.PI);
		}
		// historymenu.innerHTML += "<BR>sin<SUP>-1</SUP>(" + oldValue + ") = " + format(value);
	}
	else if(f=="atan"){
		if(angleMeasure=="deg"){
			value = Math.atan(value) * (180 / Math.PI);
		}
		else if(angleMeasure=="rad"){
			value = Math.atan(value);
		}
		else if(angleMeasure=="grad"){
			value = Math.atan(value) * (200 / Math.PI);
		}
		// historymenu.innerHTML += "<BR>tan<SUP>-1</SUP>(" + oldValue + ") = " + format(value);
	}
	update();
}