#!/usr/bin/env perl

use strict;
use CGI;
use CGI::Carp qw ( fatalsToBrowser );
use File::Basename;
use File::Spec;

my $cgi = new CGI;

my $path = "./shared/";
##########################################################################################
print "Content-type: text/html\n\n";
print <<EOP ;
<html>
<head>
	<META http-equiv="Content-Type" content="text/html; charset=UTF-8">
	<META HTTP-EQUIV="expires" CONTENT="0">
	<META HTTP-EQUIV="cache-control" CONTENT="no-cache">
	<META HTTP-EQUIV="pragma" CONTENT="no-cache">
	<META name="viewport" content="user-scalable=no, width=320, initial-scale=1">
	<link rel="stylesheet" type="text/css" href="ctr.css" />
</head>
<body id="body1screen">
	<div class="lowerscreenonly">
		<!-- TOOLBAR START -->
		<a href="index.html"><img class="toolbar_icon" id="tbHome" src="img/toolbar_home.png"></a><br/><br/>
		<!-- TOOLBAR END -->
		<div style='width:320px; height:160px; overflow:auto;'>        
		<ol start='1'>
EOP
	######################################################################################
	opendir my $dh, $path or die $!;
	my @entries = grep { $_ !~ /^ \. $/x && -f "$path/$_"} readdir $dh; # visible files only
	my $num = @entries;
	closedir $dh;
	for my $entry ( sort { $a cmp $b } @entries ) {
		my $abs_entry = File::Spec->catfile( $path, $entry );
		my $anchor = $cgi->a( { 'href' => "$abs_entry" }, $entry );
        my $filesize = sprintf("(%.2f KB)",(-s $abs_entry) / 1024);
		print "\t\t\t", $cgi->li($anchor, $filesize), "\n";
	}
	if (!$num) { #empty list
		print "\t\t\tDirectory is empty!";
	}
	######################################################################################
print <<EOP;
		</ol>
		</div>
	</div>
</body>
</html>
EOP
